# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2010-2012 ASPerience SARL (<http://www.asperience.fr>). 
#    All Rights Reserved
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

import wizard
import pooler
import base64
import os
from tools import ustr
from tools import config 

init_form = '''<?xml version="1.0"?>
<form string="Import File">
	<field name="filename" colspan="4" invisible="1"/>
	<field name="file" filename="filename" colspan="4"/>
</form>'''

init_fields = {
	'file': {'string': 'File', 'type': 'binary', 'required': True},
	'filename': {'string': 'Filename', 'type':'char', 'size': 64, 'required': True},
}

ok_form = '''<?xml version="1.0"?>
<form string="Import File">
	<field name="filename" colspan="4"/>
</form>'''

ok_fields = {
	'filename': {'string': 'Filename', 'type':'char', 'size': 64, 'required': True},
}

finish_form ='''<?xml version="1.0"?>
<form string="File import">
    <label string="File successfully imported !" colspan="4"/>
    <field name="result" nolabel="1" colspan="4"/>
</form>
'''
finish_fields = {
	'result': {'string': 'Result', 'type':'text'},
}

class wizard_import_file(wizard.interface):
	def _get_defaults(self, cr, uid, data, context):
		
		try:
			if config['edi_path'][-1]!= "/":
				config['edi_path'] += "/"
			data['form']['path_import'] = config['edi_path']+cr.dbname.strip()+"/"
		except:
			data['form']['path_import'] = "/tmp/"
		
		if 'filename' in data['form'] and data['form']['filename']:
			data['form']['filename'] = data['form']['filename'].replace("C:\\fakepath\\","")
			data['form']['filename'] = data['form']['path_import']+data['form']['filename']
			
		return data['form']
	
	def _import(self, cr, uid, data, context):
		datas = data['form']['file']
		vals =base64.decodestring(datas)
		fp = open(data['form']['filename'],'wb')
		fp.write(vals)
		fp.close()
		data['form']['result'] = "\n".join(os.listdir(data['form']['path_import']))
		return data['form']

	states = {
		'init': {
			'actions': [],
			'result': {'type':'form', 'arch':init_form, 'fields':init_fields, 'state':[('end','Cancel'),('ok','OK')]}
		},
		'ok': {
			'actions': [_get_defaults],
			'result': {'type':'form', 'arch':ok_form, 'fields':ok_fields, 'state':[('end','Cancel'),('import','Import')]}
		},
		'import': {
			'actions': [_import],
			'result': { 'type':'form', 'arch':finish_form, 'fields':finish_fields, 'state':[('init','Restart'),('end','Close')] }
		},
	}
wizard_import_file('asperience_edi.wizard_import_file')
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4: